part of xwidgetbase;

class XItem extends StatelessWidget {
  final bool titleOnTop;
  final String? title;
  final Color? titleColor;
  final TextStyle? titleStyle;
  final Widget? titleWidget;
  final TextAlign titleTextAlign;
  final double titleContainerWidth;
  final double? titleContainerHeight;
  final AlignmentGeometry? titleAlignOnTop;
  final AlignmentGeometry? titleAlignOnLeft;
  final Color? titleBackGroundColor;
  final double? titleWidthBorder;
  final Color? colorCard;
  final CrossAxisAlignment? crossAxisAlignmentXItem;
  final MainAxisAlignment? mainAxisAlignmentXItem;
  final List<Widget>? children;
  // final bool visibleBottomBorderOfCard;
  final CrossAxisAlignment? childrensCrossAxisAlignment;
  final BoxConstraints? constraintsOfXItem;
  final Axis? wrapDirection;
  final double? heightContainerForChildren;

  final Function()? onTap;
  XItem({
    Key? key,
    this.onTap,
    this.wrapDirection,
    this.titleAlignOnTop,
    this.mainAxisAlignmentXItem,
    this.heightContainerForChildren = double.infinity,
    this.titleWidget,
    this.crossAxisAlignmentXItem,
    this.colorCard,
    this.titleStyle,
    this.titleAlignOnLeft,
    // this.visibleBottomBorderOfCard = false,
    this.titleColor,
    this.title = "",
    this.titleContainerWidth = 150,
    this.titleContainerHeight,
    this.children,
    this.childrensCrossAxisAlignment,
    this.titleOnTop = false,
    this.titleTextAlign = TextAlign.center,
    this.titleBackGroundColor,
    this.titleWidthBorder,
    double? width,
    double? height,
    BoxConstraints? constraintsOfXItem,
  })  : constraintsOfXItem = (width != null || height != null) ? constraintsOfXItem?.tighten(width: width, height: height) ?? BoxConstraints.tightFor(width: width, height: height) : constraintsOfXItem,
        super(key: key);
  @override
  Widget build(BuildContext context) {
    return GestureDetector(
        onTap: onTap,
        child: ConstrainedBox(
          constraints: constraintsOfXItem ?? BoxConstraints(),
          child: Container(
            child: Card(
              color: colorCard ?? Colors.transparent,
              child: Container(
                  // decoration: visibleBottomBorderOfCard == true ? BoxDecoration(border: Border(bottom: BorderSide(width: 6, color: Colors.blue.withOpacity(0.5)))) : null,
                  child: Column(
                mainAxisAlignment: mainAxisAlignmentXItem ?? MainAxisAlignment.center,
                crossAxisAlignment: crossAxisAlignmentXItem ?? CrossAxisAlignment.center,
                children: [
                  !titleOnTop || title == null
                      ? Container()
                      : Container(
                          alignment: titleAlignOnTop ?? Alignment.center,
                          width: titleContainerWidth,
                          height: titleContainerHeight,
                          color: titleBackGroundColor != null ? null : titleColor ?? Colors.transparent,
                          margin: EdgeInsets.fromLTRB(0, 0, 0, 0),
                          decoration: titleBackGroundColor != null
                              ? BoxDecoration(
                                  color: titleBackGroundColor ?? Colors.transparent,
                                  border: Border(
                                    top: BorderSide(color: titleColor ?? Colors.transparent, width: titleWidthBorder ?? 2),
                                    left: BorderSide(color: titleColor ?? Colors.transparent, width: titleWidthBorder ?? 2),
                                    right: BorderSide(color: titleColor ?? Colors.transparent, width: titleWidthBorder ?? 2),
                                    // bottom: BorderSide(color: colortitle ?? Colors.transparent, width: widthBorderTitleContainer ?? 2),
                                  ))
                              : null,
                          child: titleWidget ??
                              Container(
                                alignment: titleAlignOnTop,
                                height: titleContainerHeight,
                                child: Text(title!, textAlign: titleTextAlign, style: titleStyle ?? XStyles.xStyTextForLabel()),
                              )),
                  Row(children: [
                    titleOnTop || title == null
                        ? Container()
                        : Container(
                            alignment: titleAlignOnLeft ?? Alignment.center,
                            width: titleContainerWidth,
                            height: titleContainerHeight,
                            padding: EdgeInsets.symmetric(vertical: 2),
                            color: titleColor ?? Colors.transparent,
                            margin: EdgeInsets.fromLTRB(0, 0, 0, 0),
                            child: titleWidget ??
                                Container(
                                  height: titleContainerHeight,
                                  child: Text(
                                    title!,
                                    textAlign: titleTextAlign,
                                    style: titleStyle ?? XStyles.xStyTextForLabel(),
                                  ),
                                )),
                    Container(
                      height: heightContainerForChildren,
                      // color: Colors.white,
                      child: Row(children: [
                        Expanded(
                          child: Wrap(crossAxisAlignment: WrapCrossAlignment.center, direction: wrapDirection ?? Axis.horizontal, spacing: 5, runSpacing: 5, children: children!),
                        )
                      ]),
                    )
                  ]),
                ],
              )),
            ),
          ),
        ));
  }
}
